#include "PainterEngine_Application.h"
#include "./architecture/PainterEngine_Designer.h"
PX_Application App;


px_int APP_ExplorerGetPathFolderCount(const px_char* path, const char* filter)
{
	return PX_FileGetDirectoryFileCount(path, PX_FILEENUM_TYPE_FOLDER, filter);
}
px_int APP_ExplorerGetPathFileCount(const px_char* path, const char* filter)
{
	return PX_FileGetDirectoryFileCount(path, PX_FILEENUM_TYPE_FILE, "wav\0WAV\0Wav\0");
}

px_int APP_ExplorerGetPathFolderName(const char path[], int count, char FileName[][260], const char* filter)
{
	return PX_FileGetDirectoryFileName(path, count, FileName, PX_FILEENUM_TYPE_FOLDER, filter);
}

px_int APP_ExplorerGetPathFileName(const char path[], int count, char FileName[][260], const char* filter)
{
	return PX_FileGetDirectoryFileName(path, count, FileName, PX_FILEENUM_TYPE_FILE, "wav\0WAV\0Wav\0");
}

px_bool PX_ApplicationInitialize(PX_Application *pApp,px_int screen_width,px_int screen_height)
{
	
	PX_ApplicationInitializeDefault(&pApp->runtime, screen_width, screen_height);
	//ʼģ
	if (!PX_FontModuleInitialize(&pApp->runtime.mp_resources, &pApp->runtime.fontmodule))return PX_FALSE;
	//ģ
	if (!PX_LoadFontModuleFromFile(&pApp->runtime.fontmodule, "assets/font.pxf"))return PX_FALSE;

	pApp->root = PX_Object_ExplorerCreate(&pApp->runtime.mp_ui, pApp->root, 0, 0, pApp->runtime.surface_width, pApp->runtime.surface_height, &pApp->runtime.fontmodule,
		APP_ExplorerGetPathFolderCount,
		APP_ExplorerGetPathFileCount,
		APP_ExplorerGetPathFolderName,
		APP_ExplorerGetPathFileName,
		""
	);
	PX_Object_ExplorerOpen(pApp->root);
	return PX_TRUE;
}

px_void PX_ApplicationUpdate(PX_Application *pApp,px_dword elpased)
{
	PX_ObjectUpdate(pApp->root,elpased);
}

px_void PX_ApplicationRender(PX_Application *pApp,px_dword elpased)
{
	px_surface *pRenderSurface=&pApp->runtime.RenderSurface;
	PX_RuntimeRenderClear(&pApp->runtime,PX_OBJECT_UI_DEFAULT_BACKGROUNDCOLOR);
	PX_ObjectRender(pRenderSurface, pApp->root,elpased);
}

px_void PX_ApplicationPostEvent(PX_Application *pApp,PX_Object_Event e)
{
	PX_ObjectPostEvent(pApp->root,e);
}
